/*
 *	File:		x80.h
 *				1993-1995 metrowerks Inc. All rights reserved
 *
 *	Content:	workaround for lack of 'long double' support in CodeWarrior for PowerPC
 *
 *	Use these routines instead of x80told() and ldtox80() from <fp.h>.
 *
 *	CodeWarrior does not support the 128-bit 'long double' format expected
 *	by the various MathLib routines. All of these routines have 'double'
 *	counterparts except for x80told() and ldtox80(). We provide 'double'
 *	versions of those routines here.
 */

#ifndef __X80__
#define __X80__

#ifndef __TYPES__
#include <Types.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

extern void x80tod ( const extended80 *x80, double *x );
extern void dtox80 ( const double *x, extended80 *x80 );

#ifdef __cplusplus
}
#endif

#endif
